pub use std::future::Future;

pub use tokio::pin;
pub use tokio::select;
pub use tokio::sync::oneshot::{channel as oneshot, Receiver as Deferred, Sender as Promise};
pub use tokio::task::JoinHandle;

pub mod log {
    pub use tracing::{debug, error, info, warn};
}

pub type Result<T> = std::result::Result<T, anyhow::Error>;

pub type ByteVec = Vec<u8>;

pub fn fail(msg: &'static str) -> anyhow::Error {
    anyhow::Error::msg(msg)
}
